
function im_adjust_clip=convertAndColorCorrect(im_path, maxSize, gamma, clip_factor)

if (nargin < 3)
    gamma=0.5;
end
if (nargin < 4)
    clip_factor=0.005;
end

max_red_increase=1.5;

im_name=strtok(im_path,'.');
[p,f,ext] = fileparts(im_path);
mkdir('LoadImage');
copyfile(im_path, 'LoadImage');


dcraw_command=sprintf('! dcraw -4 %s',['LoadImage/' f ext])
eval(dcraw_command)
im=double(imread(['LoadImage/' f '.ppm']));
delete(['LoadImage/' f '.ppm']);
delete(['LoadImage/' f ext ]);
rmdir('LoadImage');

disp(['File loaded...']);


if(max(size(im)) > maxSize)
   disp(['Image size ' num2str(size(im,1)) ' x ' num2str(size(im,2)) ]);
   disp(['Resizing down to ' num2str(maxSize) ' pixels...']); 
    if (nargin < 2)
        resize_factor=0.25;
    else
        maxSizeIm=max(size(im));
        resize_factor=0.999*maxSize/maxSizeIm;
    end
end


im=imresize(im,resize_factor);

disp('Adjusting color...');

%adjustments
im_adjust=adjust(im,gamma,2);
im_adjust_clip=adjust(im,gamma,1,[clip_factor 1-clip_factor]);
red_increase=(norm(im_adjust_clip(:,:,1)/norm(im_adjust_clip(:))))/ (norm(im_adjust(:,:,1)/norm(im_adjust(:))));
while(red_increase>max_red_increase)
    clip_factor=clip_factor/2;
    im_adjust_clip=adjust(im,gamma,1,[clip_factor 1-clip_factor]);
    red_increase=(norm(im_adjust_clip(:,:,1)/norm(im_adjust_clip(:))))/ (norm(im_adjust(:,:,1)/norm(im_adjust(:))));
end

end