addpath('bspline');

load('temp.mat');

figure;
imshow(img,'border','tight');

figure;
imshow(labels_out,'border','tight');
[C h2] = contour(labels_out,'Visible','off');

hc = get(h2,'Children');
v = get(hc(1),'Vertices');
C = [v(1:end-1,1)'; v(1:end-1,2)'];

figure;
plot(v(:,1), v(:,2),'ro');

figure;
plot(C(1,:),C(2,:),'ro');

%creat mask
BW = roipoly(img, v(1:end-1,1)', v(1:end-1,2)');

hh=figure;
imshow(BW)
stats = regionprops(double(BW2),'Area','BoundingBox','MajorAxisLength','MinorAxisLength')
rectangle('Position',stats.BoundingBox,'EdgeColor',[0 1 1])
%[C] = contourc(BW2,[0 0]);
%[r, c] = find(BW2(:)==1);
%ell = fit_ellipse(double(r),double(c),hh);

v = get(hc(2),'Vertices');
C = [C(1,:) v(1:end-1,1)'; C(2,:) v(1:end-1,2)'];
BW = BW | roipoly(img, v(1:end-1,1)', v(1:end-1,2)');

v = get(hc(3),'Vertices');
C = [C(1,:) v(1:end-1,1)'; C(2,:) v(1:end-1,2)'];

BW = BW | roipoly(img, v(1:end-1,1)', v(1:end-1,2)');
%BW = poly2mask(C(1,:),C(2,:),size(labels_out,1), size(labels_out,2));
%roipoly() is interactive
%figure; imshow(BW);

%BW = labels_out;

%crop
seg_img = repmat(BW,[1,1,3]);
seg_img = uint8(seg_img) .* uint8(img);

imshow(seg_img,'border','tight');

figure;
step = 50;
x = C(1,:);
x = x(2:step:end);
y = C(2,:);
y = y(2:step:end);

hold on;
plot(x,y,'r.');

k = convhull(x,y);
plot(x(k),y(k),'r-',x,y,'b+')


% B-spline order (defaults to cubic spline, n = 4)
n=2;
z = repmat(0,size(x));
w = repmat(1,size(x));

t = [ repmat(0, 1, n-1) linspace(0,1,numel(x)-n+2) repmat(1, 1, n-1) ];  % knot vector
X = bspline_wdeboor(n,t,[x;y;z],w);

figure;
plot(X(1,:),X(2,:),'g.');
hold on;
plot(x,y,'bo');

%creat mask
BW = roipoly(img, X(1,:), X(2,:));
%roipoly() is interactive


%crop
seg_img = repmat(BW,[1,1,3]);
seg_img = uint8(seg_img) .* uint8(img);

figure;
imshow(seg_img,'border','tight');

%select a contour from multiple contours
figure;
[C h] = contour(labels_out,[0 0]);
plot(C(1,:),C(2,:),'r.');
[x y ] =ginput(1);
%[in, index] = inpolygons(x,y,C(1,:),C(2,:)); 
% in == 1 if [x y] is inside a contour, index == the index of the contour
% containing the point

hc = get(h,'Children');
for i = 1:size(hc,1)

c1= get(hc(i),'Vertices');
[in] = inpolygon(x,y,C(1,:),C(2,:));
if(in == 1)
hold on;
plot(c1(:,1),c1(:,2),'bo');
end
end
