function display_img(handles,img)

layer_contour_style = {'co' ; 'bx'; 'cx'; 'bo' ;'cd' ;'bd' ; 'cp'; 'bp';};
layer_contour_color = {'w'; 'c'; 'm'; 'b'; 'r'; 'y' };

pointsStatus = get(handles.points_check,'Value');
contourStatus = get(handles.contour_checkbox6, 'Value');
segmentStatus = get(handles.segment_checkbox7, 'Value');
axes(handles.axes1); %select axes1 to display image

if(nargin == 1)
    if(segmentStatus)
        imshow(handles.seg_img);
    else
        imshow(handles.img);
    end
else
    imshow(img);
end;
if(pointsStatus)
    %if box is checked, text is set to bold
   hold on;
    [r c] = find(handles.labels==1);
    plot( c,r, 'r.','MarkerSize',20);
    hold on;
    [r c] = find(handles.labels==-1);
    plot(c,r, 'y.','MarkerSize',20);
end
if(contourStatus)
    
    %if( ~isempty(handles.orig_labels_out) )
    %    contour(handles.orig_labels_out,[0 0],'c', 'linewidth',1);
    %end

    %display all layers contour (except layer 1, which is outside)
    for i = 2:size(handles.layers,2)
        if (size(handles.layers,2)>1 && handles.disp_layers(i) == 1 && ...
                i ~= handles.layer_num)
                %contour(handles.layers{i}.labels_out,[0 0 0 ],...
                %C = contourc(handles.layers{i}.labels_out);
                %step = round(size(C,2)/40);
                %plot( C(1,3:step:end), C(2,3:step:end),...
                %layer_contour_style{mod(i,size(layer_contour_style,1))},...
                %'linewidth',2,'MarkerSize',6 );
                warning off;
                l = double(handles.layers{i}.labels_out);
                contour(l,[0 0 0],...
                    layer_contour_color{mod(i,size(layer_contour_color,1))},...
                    'linewidth',2);
                contour(l,[0 0 0],'k','linewidth',1);
                warning on;
        end
    end
    
    
    if( isfield(handles,'inside_contour') && ~isempty(handles.inside_contour) )
        plot(handles.inside_contour(1,:),handles.inside_contour(2,:),'yx',...
             'MarkerSize',10); 
    end
    
    if( isfield(handles,'outside_contour') && ~isempty(handles.outside_contour))
        plot(handles.outside_contour(1,:),handles.outside_contour(2,:),'m*',...
        'MarkerSize',2);
    end
    
    if(size(unique(handles.labels_out(:))) == 1)
        return;
    end
    
    hold on;
    contour(handles.labels_out,[0 0 0],'g','linewidth',2);
    contour(handles.labels_out,[0 0 0],'k','linewidth',1);
    
    
end