function [I xmin xmax ymin ymax] = draw_box(I, y, x, h, w, color)
%-------------------------------------------------------------------------%
% Assumes the image is of RGB form, in a matrix, X x Y x 3 and sets the
% specified values according to the image color level
%-------------------------------------------------------------------------%

    if size(color, 2) ~= 3
        disp('Draw box error: invalid color');
        return
    end

    [dimy dimx] = size(I);
    ymin        = max(1, y - h);
    ymax        = min(dimy, y + h);
    xmin        = max(1, x - w);
    xmax        = min(dimx, x + w);

	I(ymin : ymax, xmin, 1) = color(1, 1);
    I(ymin : ymax, xmin, 2) = color(1, 2);
    I(ymin : ymax, xmin, 3) = color(1, 3);
    
	I(ymin : ymax, xmax, 1) = color(1, 1);
    I(ymin : ymax, xmax, 2) = color(1, 2);
    I(ymin : ymax, xmax, 3) = color(1, 3);
    
    I(ymin, xmin : xmax, 1) = color(1, 1);
	I(ymin, xmin : xmax, 2) = color(1, 2);
	I(ymin, xmin : xmax, 3) = color(1, 3);
    
    I(ymax, xmin : xmax, 1) = color(1, 1);
	I(ymax, xmin : xmax, 2) = color(1, 2);
	I(ymax, xmin : xmax, 3) = color(1, 3);
end
