function [labels button] = getLabels(img,labels, Select)

%Select -> 'select' for selecting foreground and background
%           'deselect' for deselecting
%           

[rows cols dim] = size(img);

if(nargin ==1)
    labels = zeros(rows, cols);
    
else
    si = size(img);
    sl = size(labels);
    assert(all(sl(1:2)==si(1:2)),...
         'labels and image must be the same size');
end

if(nargin == 2 )
    Select = 'select';
end
    

disp('left click on foreground, right click on background');

if(nargin ==2)
    hold on;
    [r c] = find(labels==1);
    plot(c,r, 'r,','MarkerSize',20);
    hold on;
    [r c] = find(labels==-1);
    plot(c,r, 'y,','MarkerSize',20);
end


[y x button] = ginput(1); %grab labels with mouse clicks
while(~isempty(button) && (button == 1 || button == 3))
   
    % 1 -> left click button, foreground
    % 3 -> right click button, background

    x=round(x); % make all int index
    y=round(y);

    if( ~isempty(x) && (x(end)<0 || y(end) < 0 || y(end) > cols || x(end) > rows) )
        disp('click outside the img, label not counted');
        button = [];
        return;
    end


%for i = 1:size(x,1)
%    if(button(i)==1)
%         img_with_labels = draw_box(img_with_labels,x(i),y(i),5,5,[255 0 255]);
%    end
%    if(button(i)==3)
%         img_with_labels = draw_box(img_with_labels,x(i),y(i),5,5,[255 255 0]);
%    end
%end,Right click to deselect,


    if(strcmpi(Select,'select'))
    %find the linear index of the two-dim array
    index = sub2ind(size(img), x(button==1) ,  y(button==1) );
    labels(index) = 1;
    
    index = sub2ind(size(img),  x(button==3) , y(button==3));
    labels(index) = -1;
    else

    %find the closest label to deselect
      %index to deselect (may not be exact)
      index = sub2ind(size(img),  x , y);
      
      %find the closest selected labels to be deselected
      
      [r c] = find(labels == 1 | labels == -1);
      
      i2 = sub2ind(size(img), r, c);
      m = repmat(index, size(i2));
      index = i2(find(abs(m-i2)==min(abs(m-i2))));
      
      %deslect
      labels(index) = 0;
      imshow(img);
    end

    
    hold on;
    [r c] = find(labels==1);
    plot(c,r, 'r.','MarkerSize',20);
    hold on;
    [r c] = find(labels==-1);
    plot(c,r, 'y.','MarkerSize',20);
    
    [y x button] = ginput(1); %grab labels with mouse clicks
end






