function [labels] = getSeedImg(img, labels)

[rows cols dim] = size(img);

if(nargin ==1)
    labels = zeros(rows, cols);
    
else
    si = size(img);
    sl = size(labels);
    assert(numel(unique(labels))==3,...
         'labels must be comprised of -1, 0, 1');
    assert(all(sl(1:2)==si(1:2)),...
         'labels and image must be the same size');
end

figure; %make new figure window

imshow(img);
disp('left click on foreground, right click on background');

if(nargin ==2)
    hold on;
    [r c] = find(labels==1);
    plot(c,r, 'r.','MarkerSize',20);
    hold on;
    [r c] = find(labels==-1);
    plot(c,r, 'y.','MarkerSize',20);
end

[y x button] = ginput; %grab labels with mouse clicks
% 1 -> left click button, foreground
% 3 -> right click button, background


x=round(x); % make all int index
y=round(y);


%for i = 1:size(x,1)
%    if(button(i)==1)
%         img_with_labels = draw_box(img_with_labels,x(i),y(i),5,5,[255 0 255]);
%    end
%    if(button(i)==3)
%         img_with_labels = draw_box(img_with_labels,x(i),y(i),5,5,[255 255 0]);
%    end
%end


%find the linear index of the two-dim array
index = sub2ind(size(img), x(button==1) ,  y(button==1) );
labels(index) = 1;

index = sub2ind(size(img),  x(button==3) , y(button==3));
labels(index) = -1;

imshow(img);
hold on;
[r c] = find(labels==1);
plot(c,r, 'r.','MarkerSize',20);
hold on;
[r c] = find(labels==-1);
plot(c,r, 'y.','MarkerSize',20);





