%  [labels strengths] = growcut(img, labels)
%
%  GrowCut algorithm
%  from "GrowCut" - Interactive Multi-Label N-D Image Segmentation
%       By Cellular Autonoma
%  by Vladimir Vezhnevets and Vadim Konouchine
%
%  usage: [labels, strengths] = growcutmex(image, labels)
%         image can be RGB or grayscale
%         labels has values: -1 (bg), 1 (fg), or 0 (undef.)
% 
%         resulting labels will be either 0 (bg) or 1 (fg)
%         resulting strengths will be between 0 and 1
%
%  coded by: Shawn Lankton (www.shawnlankton.com)



function [l s] = growcut(img, labels)
  
  img = double(img);
  si = size(img);
  sl = size(labels);
  assert(numel(unique(labels))==3,...
         'labels must be comprised of -1, 0, 1');
  assert(all(sl(1:2)==si(1:2)),...
         'labels and image must be the same size');
  
  %[l s] = growcutmex(img,labels);
  %return;
  
  size_fac = .5;
  i = imresize(img,size_fac);
  la = zeros( size(i,1),size(i,2));
  [r c] = find(labels == 1);
  index = sub2ind(size(i), ceil(r*.5), ceil(c*.5));
  la(index) = 1;
  [r c] = find(labels == -1);
  index = sub2ind(size(i), ceil(r*.5), ceil(c*.5));
  la(index) = -1;
  
  [lout s] = growcutmex(i,la);
  l = imresize(lout,[size(img,1), size(img,2)]);
  return;
  %% --------------------------------filters--------------------------
  % set up filters
  addpath(genpath('toolbox'));
  %%I=imResample(img,0.25);

  %{
  I1=double(rgb2gray(uint8(img)));
  fb=FbMake(2,1,0); fb=imResample(fb,2);
  %FR=FbApply2d(I1,fb,'same',0); 
  FR=FbApply2d(I1,fb,'same',1); 
  FR=gaussSmooth(FR,[1 1 0],'same');
  %FR = (FR+255)/510; %normalize between [-255, 255]
  bound = max(max(FR(:)), -min(FR(:)))
  FR = (FR+bound)/(bound*2); %[-bound, bound]
  %}
  
  filters = [];
  
  %filters = main_func(img);
  %filters = FR;
  %filters = cat(3,img/255, FR); %add filters to RGB
  %filters = FR(:,:, 38:40);
  
  
    
  filters = img/255;
  
  
  disp('making textons...')
  %filters = main_func(img);  filters = filters / max(filters(:));
  
  
  %save(['filters.mat'],'filters','-mat');
  load('filters12.mat')
  filters = filters1;
  
  %filters = filters / max(filters(:));
  
 % figure(2); montage3(filters, size(filters,1),size(filters,2), 40);
 
 figure(7); imagesc(filters); colormap gray
  
  bound = max(max(filters(:)), -min(filters(:)))
  filters = (filters+bound)/(bound*2); %[-bound, bound]
  
  filters = cat(3,img/255, filters); %add filters to RGB
  
  disp('running growcut...')
  [l s] = growcutmex_with_filters(filters,labels); %img have RGB + other filters
  %%l = imResample(l,4)>0; %decimal to binary
