function [ seg_img new_labels_out] = segmentGeodesicStar(img, labels)
   %Geodesic Star Convexity
   % http://www.robots.ox.ac.uk/~vgg/software/iseg/

    % Make segmentation options
    opts=bj.segOpts(); % You can use other methods such as gsc.opts() or gscSeq.opts();

    % Customise the options if you need
    opts.postProcess=1;
    opts.gcGamma=150;

    % Intialize the segmentation object 
    segH=bj.segEngine(0,opts); % Again, you can use other methods such as gsc.segEngine() or
                               % gscSeq.segEngine(), but make sure you call the same
                               % package you used to build the options for

    % preProcess image
    segH.preProcess(im2double(img)); % Only takes in double images

    labels(labels == -1) = 2;
    
    % Get the first segmentation
    ok=segH.start(labels);

    % You can access the segmentation obtained using
    %figure;imshow(segH.seg);
    
    new_labels_out = segH.seg;
    new_labels_out(new_labels_out == 255) = 1;
    
    seg_img = repmat(new_labels_out,[1,1,3]);

    seg_img = uint8(seg_img) .* uint8(img);


    % Delete the segmentation object
    delete(segH);

    % Another function that is more useful in an interactive setting is
    % updateSeg -- for making edits to the obtained segmentation 
    % you should call segH.updateSeg(newLabels) where newLabels would be the updated
    % brush strokes. In an offline setting, you probably dont need to call updateSeg

end