%-- Tests growcut.m

%load test_data
%img = imresize(imread('IMG_3586.JPG'), .5);

labels = getSeedImg(img);

figure;
subplot(2,2,1), imshow(img); title('Image');
subplot(2,2,2), imshow(labels,[]); title('Seeds');

[labels_out, strengths] = growcut(img,labels);
labels_out = medfilt2(labels_out,[9,9]);

subplot(2,2,3), imshow(img);
hold on;
contour(labels_out,[0 0],'g','linewidth',4);
contour(labels_out,[0 0],'k','linewidth',2);
hold off;
title('Output');

subplot(2,2,4), imshow(labels_out);
title('Binary Output');

figure;
imshow(img);
hold on;
contour(labels_out,[0 0],'g','linewidth',4);
contour(labels_out,[0 0],'k','linewidth',2);
hold on;
[r c] = find(labels==1);
plot(c,r, 'r*','MarkerSize',10);
hold on;
[r c] = find(labels==-1);
plot(c,r, 'y*','MarkerSize',10);
hold off;
title('Output');

old_labels = labels;
labels = getSeedImg(img,labels);