
function filters = main_func(img)
%% set params and read image
I = img;

nbrClusters = 30;
scale = 1;


%addpath('./Serges Code');

I = I./(max(I(:)));
I = rgb2gray(imresize(I, 1));

f = figure(2);
imagesc(I)
colormap gray
I=I;
set(f, 'Color', [0 0 0])
imagesc(I)

%% make filters
sigmaScales = [1 2 5];
nbrPixelsFilters = 35;
[FB,M1,M2,N3]=make_filterbank_mod(nbrPixelsFilters, sigmaScales);
FI = fft_filt_2(I, FB, scale);

figure(1)
montage3(FB,nbrPixelsFilters,nbrPixelsFilters,40);

figure(2)
 n = 2;
 imagesc(FI(:,:,n));


%% cluster and create heat map
% create vectors.
X = zeros(size(I,1)*size(I,2), 40);
row = 1;
for i = 1 : size(I,1)
    for j = 1 : size(I,2)
        X(row, :) = FI(i,j,:);
        row = row + 1;
    end
end

X = X(1:10:end,:);
[IDX, C, d] = kmeans2( X, nbrClusters);

textonMap = zeros(size(I));
for row = 1 : size(I,1)
    for col = 1 : size(I,2)
        v = FI(row,col,:);
        [a b] = min(sum((repmat(v(:)', nbrClusters, 1) - C).^2, 2));
        textonMap(row, col) = b;
    end
end
f = figure(3);
imagesc(textonMap)
% axis off
colormap jet
% saveas(f,'img3.jpg')

% calculate integral image
II = zeros(size(textonMap,1 ), size(textonMap,2 ), nbrClusters);
for i = 1:nbrClusters
    II(:,:,i) = double((textonMap == i));
    II(:,:,i) = cumsum(cumsum(II(:,:,i), 2), 1);
end

%% Grab a texture area
figure(2);
squareSize = 29;
imagesc(I)
colormap gray
disp('input two points as the feature');
[x, y] = ginput(2);
patch = FI(round(y(1)):round(y(2)),round(x(1)):round(x(2)),:);
h = zeros(1, nbrClusters);
%create histogram
for i = 1 : size(patch, 1)
    for j = 1 : size(patch, 2)
        v = patch(i,j,1:end);
        [a b] = min(sum((repmat(v(:)', nbrClusters, 1) - C).^2, 2));
        h(b) = h(b) + 1;
    end
end
h = h./sum(h) * squareSize^2;
% figure(4)
% bar(h)

% create heat map using chi2 distance.
heatMap = ones(size(I));
margin = floor(squareSize/2);
for row = margin + 2 : size(I,1) - margin
    for col = margin + 2 : size(I,2) - margin
        thisH = II(row + margin, col + margin, :) + II(row - margin - 1, col - margin - 1, :) - II(row - margin - 1, col + margin, :) - II(row + margin, col - margin - 1, :) ;
        %integral image, to extract histogram faster
        thisH = thisH(:)';
        warning off;
        chi2 = ( (thisH - h).^2 )./ (h + thisH);
        warning on ;
        %diff betw two histograms, square it, then normalize
        chi2(isnan(chi2)) = 0;
        chi2 = sum(chi2);
        heatMap(row, col) = chi2;
    end
end
heatMap = max(heatMap(:)) - heatMap ;


figure(4)
imagesc(heatMap);
colormap gray

figure(7)
smoothMap = gaussSmooth(heatMap,[3 3 0],'same');
imagesc(smoothMap);
colormap gray

figure(8)
mask = smoothMap > max(smoothMap(:)*.85);
imshow(mask,'border','tight');

filters = smoothMap;

